<?php
 /* credits.php -- provides an on-page credits block
  * Copyright 2004, Evan Prodromou <evan@pigdog.org>.
  * 
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation; either version 2 of the License, or
  *  (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program; if not, write to the Free Software
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */

if (!defined('PmWiki')) exit();

$CreditBlockVersion = '0.1';

SDV($CreditLimit, -1);
SDV($CreditLastFmt, "Last edited by \$last.");
SDV($CreditOthersFmt, "Based on work by \$others.");
SDV($CreditAnonymous, "an anonymous user of $WikiTitle");
SDV($CreditAnonymousPlural, "anonymous users of $WikiTitle");
SDV($CreditAnd, "and");
SDV($CreditComma, ",");

function ListToText($l) {			

    global $CreditAnd, $CreditComma;
	
    $s = "";
    $m = count($l) - 1;
    for ($i = $m; $i >= 0; $i--) {
        if ($i == $m) {
	    $s = $l[$i];
        } else if ($i == $m - 1) {
	    $s = $l[$i] . " " . $CreditAnd . " " . $s;
        } else {
            $s = $l[$i] . $CreditComma . " " . $s;
        }
    }	
    
    return $s;
}

function MakeCreditBlock($pagename) {

    global $CreditLimit;
    
    $block = '';
    
    if ($CreditLimit != 0) {

	global $CreditLastFmt, $CreditAnonymous;
	global $DefaultGroup, $DefaultTitle;
	
	if ($pagename == '') $pagename = "$DefaultGroup/$DefaultTitle";
    
	$page = RetrieveAuthPage($pagename,"read");
	if (!$page) return '';
	Lock(0);
    
	$last_author = @$page['author'];

	if (strlen($last_author) == 0) {
	    $last_author = $CreditAnonymous;
	}
	
	# FIXME: format this correctly
	
	$last = str_replace('$last', $last_author, $CreditLastFmt);

	$contrib = '';
	
	if ($CreditLimit > 1 || $CreditLimit < 0) {

	    global $CreditOthersFmt, $CreditAnonymousPlural;
	    
	    $contributors = array();

	    foreach ($page as $k=>$v) {
		if (preg_match('/^author\:\d+/', $k)) {
		    if (strlen($v) == 0) {
			$v = $CreditAnonymousPlural;
		    }
		    if (strcmp($v, $last_author) != 0 &&
			!in_array($v, $contributors)) {
			$contributors[] = $v;
		    }
		}
	    }

	    if (count($contributors) > 0) {
		$contrib = str_replace('$others', ListToText($contributors), $CreditOthersFmt);
	    }
	}
	
	$block = $last . ' ' . $contrib;
    }
    
    return $block;
}

$CreditBlock = MakeCreditBlock($pagename);

?>
